﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CustomUndoAction
{
    public partial class AddRowForm : Form
    {
        // add a delegate
        public delegate void RowsUpdateHandler(object sender, RowsUpdateEventArgs e);

        // add an event of the delegate type
        public event RowsUpdateHandler RowsUpdated;

        public AddRowForm()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (textBox1.Text != "" && textBox2.Text != "")
            {
                string nRows = textBox1.Text;
                string rIndex = textBox2.Text;
                RowsUpdateEventArgs args = new RowsUpdateEventArgs(nRows, rIndex);
                RowsUpdated(this, args);
                this.Dispose();
            }

            else
            {
                MessageBox.Show("Please enter appropriate values to insert rows");
            }
        }

        private void AddRowForm_Load(object sender, EventArgs e)
        {
            textBox1.KeyPress += new KeyPressEventHandler(textBox1_KeyPress);
            textBox2.KeyPress += new KeyPressEventHandler(textBox2_KeyPress);
        }

        void textBox2_KeyPress(object sender, KeyPressEventArgs e)
        {
             if (char.IsDigit(e.KeyChar) || char.IsControl(e.KeyChar))
              {
                e.Handled = false;
              }
            else
              {
                e.Handled = true; 
              }
        }

        void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (char.IsDigit(e.KeyChar) || char.IsControl(e.KeyChar))
            {
                e.Handled = false;
            }
            else
            {
                e.Handled = true;
            }
        }

      
    }

    public class RowsUpdateEventArgs : System.EventArgs
    {
        private string rind;
        private string nrow;

        public RowsUpdateEventArgs(string nr, string ri)
        {
            this.rind = ri;
            this.nrow = nr;
        }
       
       public string _NoOfRows
        {
            get
            {
                return nrow;
            }
        }

        public string _RowIndex
        {
            get
            {
               return rind;
            }
        }
        
    }

}
