﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CustomUndoAction
{
    public partial class Form1 : Form
    {
        int temprow, temprowindex;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
           fpSpread1.AllowUndo = true;
           fpSpread1.Sheets[0].RowCount = 5;
           fpSpread1.Sheets[0].ColumnCount = 3;
        }

       void frm_RowsUpdated(object sender, RowsUpdateEventArgs e)
        {
            temprow = Convert.ToInt32(e._NoOfRows);
            temprowindex = Convert.ToInt32(e._RowIndex);
            AddRowsAction add = new AddRowsAction(fpSpread1.ActiveSheet, temprowindex, temprow);
            fpSpread1.UndoManager.PerformUndoAction(add);
        }

      private void changeFontToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Font f1 = new Font("Broadway", 12f, FontStyle.Bold);
            FontAction sra = new FontAction(fpSpread1.Sheets[0], f1);
            fpSpread1.UndoManager.PerformUndoAction(sra);
        }

        private void addRowsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            AddRowForm frm = new AddRowForm();
            frm.RowsUpdated += new AddRowForm.RowsUpdateHandler(frm_RowsUpdated);
            frm.ShowDialog();
        }

        private void removeRowsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            FarPoint.Win.Spread.Model.CellRange cr = fpSpread1.ActiveSheet.GetSelection(0);
            RemoveRowsAction remove = new RemoveRowsAction(fpSpread1.Sheets[0], cr);
            fpSpread1.UndoManager.PerformUndoAction(remove);
        }

       
    }

    public class RemoveRowsAction : FarPoint.Win.Spread.UndoRedo.UndoAction
    {
        FarPoint.Win.Spread.SheetView sheetView, sv;
        FarPoint.Win.Spread.Model.CellRange cr;

        public RemoveRowsAction()
        {

        }

        public RemoveRowsAction(FarPoint.Win.Spread.SheetView sheetView, FarPoint.Win.Spread.Model.CellRange scr)
        {
            this.sheetView = sheetView;
            this.cr = scr;
        }

        public override bool PerformUndoAction(object sender)
        {
            FarPoint.Win.Spread.SpreadView spreadView = null;
            if (sender is FarPoint.Win.Spread.SpreadView)
            {
                spreadView = (FarPoint.Win.Spread.SpreadView)sender;
            }
            else
            {
                return false;
            }

            if (sheetView == null)
            {
                sheetView = spreadView.GetSheetView();
            }
            if ((SaveUndoState()) & (sheetView != null))
            {
                sheetView.RemoveRows(cr.Row,cr.RowCount);
                return true;
            }
            return false;
        }

        protected override bool SaveUndoState()
        {
            sv = new FarPoint.Win.Spread.SheetView();
            if ((sheetView != null))
            {
                cr = sheetView.GetSelection(0);

                sv.RowCount = cr.RowCount;
                sv.ColumnCount = sheetView.ColumnCount;
                for (int r = 0, i = cr.Row; r < sv.RowCount; r++, i++)
                    for (int c = 0, j = 0; c < sv.ColumnCount; c++, j++)
                        sv.Cells[r, c].Value = sheetView.Cells[i, j].Value;

            }

            return (sv != null);
        }

        public override bool Undo(object sender)
        {
            FarPoint.Win.Spread.SpreadView spreadView = null;
            if (sender is FarPoint.Win.Spread.SpreadView)
            {
                spreadView = (FarPoint.Win.Spread.SpreadView)sender;
            }
            else
            {
                return false;
            }

            if ((cr != null))
            {
                sheetView.AddRows(cr.Row, cr.RowCount);
                for (int r = 0, i = cr.Row; r < sv.RowCount; r++, i++)
                    for (int c = 0, j = 0; c < sv.ColumnCount; c++, j++)
                        sheetView.Cells[i, j].Value = sv.Cells[r, c].Value;
                return true;
            }
            return false;

        }

    }

    public class FontAction : FarPoint.Win.Spread.UndoRedo.UndoAction
    {

        FarPoint.Win.Spread.SheetView sheetView;
        Font ofont, nfont;
        int row, col;

        public FontAction()
        {

        }

        public FontAction(FarPoint.Win.Spread.SheetView sheetView, Font f)
        {
            this.sheetView = sheetView;
            this.nfont = f;
        }

        public override bool PerformUndoAction(object sender)
        {
            FarPoint.Win.Spread.SpreadView spreadView = null;
            if (sender is FarPoint.Win.Spread.SpreadView)
            {
                spreadView = (FarPoint.Win.Spread.SpreadView)sender;
            }
            else
            {
                return false;
            }

            if (sheetView == null)
            {
                sheetView = spreadView.GetSheetView();
            }
            if ((SaveUndoState()) & (sheetView != null))
            {
                sheetView.ActiveCell.Font = nfont;
                return true;
            }
            return false;
        }

        protected override bool SaveUndoState()
        {
            if ((sheetView != null))
            {
                if (sheetView.ActiveCell.Font == null)
                {
                    ofont = new Font("Microsoft Sans Serif", 8.25f, FontStyle.Regular);
                    row = sheetView.ActiveCell.Row.Index;
                    col = sheetView.ActiveCell.Column.Index;
                }
                else
                {
                    ofont = sheetView.ActiveCell.Font;
                    row = sheetView.ActiveCell.Row.Index;
                    col = sheetView.ActiveCell.Column.Index;
                }
            }

            return (ofont != null);
        }

        public override bool Undo(object sender)
        {
            FarPoint.Win.Spread.SpreadView spreadView = null;
            if (sender is FarPoint.Win.Spread.SpreadView)
            {
                spreadView = (FarPoint.Win.Spread.SpreadView)sender;
            }
            else
            {
                return false;
            }

            if ((ofont != null))
            {
                sheetView.Cells[row,col].Font = ofont;
                return true;
            }
            return false;

        }

    }

    public class AddRowsAction : FarPoint.Win.Spread.UndoRedo.UndoAction
    {

        FarPoint.Win.Spread.SheetView sheetView;
        int rowsadded, rowindex;
        FarPoint.Win.Spread.Model.CellRange cr;

        public AddRowsAction()
        {

        }

        public AddRowsAction(FarPoint.Win.Spread.SheetView sheetView, int row, int count)
        {
            this.sheetView = sheetView;
            this.rowindex = row;
            this.rowsadded = count;
        }

        public override bool PerformUndoAction(object sender)
        {
            FarPoint.Win.Spread.SpreadView spreadView = null;
            if (sender is FarPoint.Win.Spread.SpreadView)
            {
                spreadView = (FarPoint.Win.Spread.SpreadView)sender;
            }
            else
            {
                return false;
            }

            if (sheetView == null)
            {
                sheetView = spreadView.GetSheetView();
            }
            if ((SaveUndoState()) & (sheetView != null))
            {
                sheetView.AddRows(rowindex, rowsadded);
                return true;
            }
            return false;
        }

        protected override bool SaveUndoState()
        {
            if ((sheetView != null))
            {
                cr = new FarPoint.Win.Spread.Model.CellRange(rowindex, 0, rowsadded, -1);
            }

            return (cr != null);
        }

        public override bool Undo(object sender)
        {
            FarPoint.Win.Spread.SpreadView spreadView = null;
            if (sender is FarPoint.Win.Spread.SpreadView)
            {
                spreadView = (FarPoint.Win.Spread.SpreadView)sender;
            }
            else
            {
                return false;
            }

            if ((cr != null))
            {
                sheetView.RemoveRows(rowindex, rowsadded);
                return true;
            }
            return false;

        }

    }

  
}
